import { ByteArray } from '../utils/ByteArray';
/**
 * @internal
 */
export declare class LzwCompressor {
    width: number;
    height: number;
    pixels: Uint8Array;
    colorDepth: number;
    initCodeSize: number;
    accum: Uint8Array;
    htab: Int32Array;
    codetab: Int32Array;
    cur_accum: number;
    cur_bits: number;
    n_bits: number;
    a_count: number;
    remaining: number;
    curPixel: number;
    free_ent: number;
    maxcode: number;
    clear_flg: boolean;
    g_init_bits: number;
    ClearCode: number;
    EOFCode: number;
    constructor(width: number, height: number, colorDepth: number);
    reset(): void;
    char_out(c: number, outs: ByteArray): void;
    cl_block(outs: ByteArray): void;
    cl_hash(hsize: number): void;
    compress(init_bits: number, outs: ByteArray): void;
    encode(pixels: Uint8Array, outs: ByteArray): void;
    flush_char(outs: ByteArray): void;
    get_maxcode(n_bits: number): number;
    nextPixel(): number;
    output(code: number, outs: ByteArray): void;
}
