import { LoaderDefinition } from './types';
export * from './types';
/**
 * Resolve a source, using the current loaders list.
 * Returns an ArrayBuffer containing the data loaded from the source.
 */
export declare const load: (source: any) => Promise<ArrayBufferLike>;
/**
 * List all currently registered loaders, as an object.
 */
export declare const list: () => {
    [k: string]: LoaderDefinition<any>;
};
/**
 * Clear all currently registered loaders.
 */
export declare const clear: () => void;
/**
 * Register a resource loader to use when loading Flipnotes.
 * A loader should take a source and return an ArrayBuffer.
 */
export declare const register: (loader: LoaderDefinition<any>) => void;
