/**
 * @internal
 */
export declare const ADPCM_INDEX_TABLE_2BIT: Int8Array;
/**
 * @internal
 */
export declare const ADPCM_INDEX_TABLE_4BIT: Int8Array;
/**
 * @internal
 */
export declare const ADPCM_STEP_TABLE: Int16Array;
/**
 * @internal
 */
export declare const pcmGetSample: (src: Int16Array, srcSize: number, srcPtr: number) => number;
/**
 * Zero-order hold (nearest neighbour) audio interpolation
 * Credit to SimonTime for the original C version
 * @internal
 */
export declare const pcmResampleNearestNeighbour: (src: Int16Array, srcFreq: number, dstFreq: number) => Int16Array;
/**
 * Simple linear audio interpolation
 * @internal
 */
export declare const pcmResampleLinear: (src: Int16Array, srcFreq: number, dstFreq: number) => Int16Array;
/**
 * Get a ratio of how many audio samples hit the pcm_s16_le clipping bounds
 * This can be used to detect corrupted audio
 * @internal
 */
export declare const pcmGetClippingRatio: (src: Int16Array) => number;
/**
 * Get the root mean square of a PCM track
 * @internal
 */
export declare const pcmGetRms: (src: Int16Array) => number;
