/**
 * Convert a Nintendo DS or 3DS timestamp integer to a JS Date object.
 * @internal
 */
export declare const dateFromNintendoTimestamp: (timestamp: number) => Date;
/**
 * Convert a JS Date to a Nintendo timestamp integer.
 */
export declare const dateToNintendoTimestamp: (date: Date) => number;
/**
 * Get the duration (in seconds) of a number of frames running at a specified framerate.
 * @internal
 */
export declare const timeGetNoteDuration: (frameCount: number, framerate: number) => number;
