/**
 * KWZ filenames can be decoded and broken down into different fields. This object represents an unpacked KWZ filename.
 */
export interface FlipnoteKwzUnpackedFilename {
    fsid: string;
    created: Date;
    edited: Date;
}
/**
 * Determines if a string matches the KWZ filename format.
 */
export declare const isKwzFilename: (filename: string) => boolean;
/**
 * Decode a KWZ filename into its constituent parts.
 */
export declare const kwzFilenameDecode: (filename: string) => FlipnoteKwzUnpackedFilename;
/**
 * Encode a KWZ filename from its parts; i.e. do the inverse of {@link kwzFilenameDecode}.
 */
export declare const kwzFilenameEncode: (filename: FlipnoteKwzUnpackedFilename) => string;
