import { FlipnoteRegion } from '../types';
/**
 * Indicates whether the input is a valid Flipnote Studio 3D user ID
 */
export declare const isKwzFsid: (fsid: string) => boolean;
/**
 * Indicates whether the input is a valid DSi Library user ID
 */
export declare const isKwzDsiLibraryFsid: (fsid: string) => boolean;
/**
 * Get the region for any valid Flipnote Studio 3D user ID.
 *
 * :::tip
 * This may be incorrect for IDs that are not from the DSi Library.
 * :::
 */
export declare const getKwzFsidRegion: (fsid: string) => FlipnoteRegion;
/**
 * Format a hex string with dashes, to match the format used to display Flipnote Studio IDs in the app.
 */
export declare const kwzFsidFormat: (hex: string) => string;
/**
 * Unformat a Flipnote Studio ID string back into regular hex.
 */
export declare const kwzFsidUnformat: (fsid: string) => string;
