import { FlipnoteFormat } from '../types';
import { DataStream } from '../../utils';
export declare const XOR_KEY: number[];
/**
 * Parsed playlist filepath.
 */
export interface Path {
    /**
     * Full original filepath.
     */
    full: string;
    /**
     * Parsed filename (e.g. `flipnote.ppm`).
     */
    name: string;
    /**
     * Parsed filename base (e.g. `flipnote`).
     */
    base: string;
    /**
     * Parsed filename extension (e.g. `ext`).
     */
    ext: string;
    /**
     * Parsed filepath folder.
     */
    folder?: string;
    /**
     * Parsed filepath parent folder - the folder one level above {@link folder}.
     */
    parentFolder?: string;
}
export declare abstract class BasePlaylistParser extends DataStream {
    abstract format: FlipnoteFormat;
    /**
     * List of filepaths in the playlist.
     */
    entries: Path[];
    constructor(buffer: ArrayBufferLike);
    addEntry(full: string): void;
}
