import { BasePlaylistParser } from './Base';
import { FlipnoteFormat } from '../types';
/**
 * Parses .pls and .lst playlist files from Flipnote Studio (DSiWare).
 *
 * > This only supports playlists from version 2 of Flipnote Studio.
 * > Since version 1 was only ever released in Japan (and for a short period of time at that) I didn't bother including support.
 *
 * File format documentation is at https://github.com/Flipnote-Collective/flipnote-studio-docs/wiki/.pls-and-.lst-files
 */
export declare class PpmPlaylist extends BasePlaylistParser {
    format: FlipnoteFormat;
    constructor(buffer: ArrayBufferLike);
}
