import { type CanvasInterface, CanvasStereoscopicMode } from './CanvasInterface';
import { type WebglCanvasOptions } from './WebGlCanvas';
import { type Html5CanvasOptions } from './Html5Canvas';
import type { Flipnote } from '../parsers';
export type UniversalCanvasOptions = WebglCanvasOptions & Html5CanvasOptions;
export declare class UniversalCanvas implements CanvasInterface {
    #private;
    /**
     *
     */
    renderer: CanvasInterface;
    /**
     *
     */
    note: Flipnote;
    /**
     * View width (CSS pixels)
     */
    width: number;
    /**
     * View height (CSS pixels)
     */
    height: number;
    /**
     * Backing canvas width (real pixels)
     * Note that this factors in device pixel ratio, so it may not reflect the size of the canvas in CSS pixels
    */
    dstWidth: number;
    /**
     * Backing canvas height (real pixels)
     * Note that this factors in device pixel ratio, so it may not reflect the size of the canvas in CSS pixels
    */
    dstHeight: number;
    /**
     *
     */
    srcWidth: number;
    /**
     *
     */
    srcHeight: number;
    /**
     *
     */
    frameIndex: number;
    /**
     *
     */
    isReady: boolean;
    /**
     *
     */
    isHtml5: boolean;
    /**
     *
     */
    supportedStereoscopeModes: CanvasStereoscopicMode[];
    /**
     *
     */
    stereoscopeMode: CanvasStereoscopicMode;
    /**
     *
     */
    stereoscopeStrength: number;
    constructor(parent: Element, width?: number, height?: number, options?: Partial<UniversalCanvasOptions>);
    fallbackIfPossible(): void;
    switchToHtml5(): void;
    setCanvasSize(width: number, height: number): void;
    setNote(note: Flipnote): void;
    clear(color?: [number, number, number, number]): void;
    drawFrame(frameIndex: number): void;
    forceUpdate(): void;
    requestStereoScopeMode(mode: CanvasStereoscopicMode): void;
    getDataUrl(type?: string, quality?: any): string;
    getBlob(type?: string, quality?: any): Promise<Blob>;
    destroy(): void;
}
