/**
 * @internal
 */
export declare class ByteArray {
    /**
     * @internal
     */
    pageSize: number;
    /**
     * Allocated size counting all pages.
     * @internal
     */
    allocSize: number;
    /**
     * Number of bytes actually used.
     * @internal
     */
    realSize: number;
    /**
     * @internal
     */
    pages: Uint8Array[];
    /**
     * @internal
     */
    numPages: number;
    /**
     * Page to write to.
     * @internal
     */
    pageIdx: number;
    /**
     * Position in page to write to.
     * @internal
     */
    pagePtr: number;
    /**
     * Position in file.
     * @internal
     */
    realPtr: number;
    constructor();
    /**
     * @internal
     */
    set pointer(ptr: number);
    /**
     * @internal
     */
    get pointer(): number;
    /**
     * @internal
     */
    newPage(): void;
    /**
     * @internal
     */
    setPointer(ptr: number): void;
    /**
     * @internal
     */
    writeByte(value: number): void;
    /**
     * @internal
     */
    writeBytes(bytes: Uint8Array | number[], srcPtr?: number, length?: number): void;
    /**
     * @internal
     */
    writeChars(str: string): void;
    /**
     * @internal
     */
    writeU8(value: number): void;
    /**
     * @internal
     */
    writeU16(value: number): void;
    /**
     * @internal
     */
    writeU32(value: number): void;
    getBytes(): Uint8Array;
    getBuffer(): ArrayBufferLike;
}
