/**
 * @internal
 */
export type AsyncTuple<ErrorType extends any = Error, DataType extends any = unknown> = [ErrorType, null] | [null, DataType];
/**
 * Gracefully handles a given Promise factory.
 *
 * Example:
 * `const [ error, data ] = await until(() => asyncAction())`
 *
 * @internal
 */
export declare const until: <ErrorType extends unknown = Error, DataType extends unknown = unknown>(promise: () => Promise<DataType>) => Promise<AsyncTuple<ErrorType, DataType>>;
